unit Unit1;

interface

uses
  Forms, Series,  Spin,  Chart, Classes, Controls, TeEngine, StdCtrls, ExtCtrls, TeeProcs,
  Filter;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    SpinEdit1: TSpinEdit;
    Series1: TLineSeries;
    Series2: TLineSeries;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Chart2: TChart;
    Series3: TLineSeries;
    SLXFilter1: TSLXFilter;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DataNum: Integer;
  LastData: Real;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  for i:=1 to 100 do begin
    LastData:=Random(100);
    SLXFilter1.AddSample(LastData);
    Series1.AddXY(i,LastData);
    Series2.AddXY(i,SLXFilter1.FilterOut);
  end;
  DataNum:=100;
  ComboBox1Change(Sender);
  DoubleBuffered:=True;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  SLXFilter1.Enabled:=CheckBox1.Checked;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var i: Integer;
begin
  SLXFilter1.Length:=SpinEdit1.Value;
  Series3.Clear;
  for i:=0 to SLXFilter1.Length-1 do begin
    Series3.AddXY(i,SLXFilter1.Window.Coeffs[i]);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  LastData:=Random(100);
  Inc(DataNum);
  SLXFilter1.AddSample(LastData);
  Series1.AddXY(DataNum,LastData);
  Series2.AddXY(DataNum,SLXFilter1.FilterOut);
  Series1.Delete(0);
  Series2.Delete(0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.Enabled:= not Timer1.Enabled;
  if Timer1.Enabled then
    Button1.Caption:=''
  else Button1.Caption:='';
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var i: Integer;
begin                 
  if ComboBox1.Text='wt_SIN3'      then SLXFilter1.Window.WindowType:=wt_SIN3;
  if ComboBox1.Text='wt_RECTANGLE' then SLXFilter1.Window.WindowType:=wt_RECTANGLE;
  if ComboBox1.Text='wt_TRIANGLE'  then SLXFilter1.Window.WindowType:=wt_TRIANGLE;
  if ComboBox1.Text='wt_CUSTOM'    then SLXFilter1.Window.WindowType:=wt_CUSTOM;
  SLXFilter1.Window.RefreshCoeffs;
  Series3.Clear;
  for i:=0 to SLXFilter1.Length-1 do begin
    Series3.AddXY(i,SLXFilter1.Window.Coeffs[i]);
  end;
end;

end.
